package igtool;
import scheme.*;
import java.net.*;
import java.io.*;

public class igtool extends ServerSocket
{
   static igtool httpd;
   static boolean keeponrunning=true;
   public igtool() throws java.io.IOException
     {
	super(8081);
     }
   public static void fatal(String s)
     {
	System.out.println(s);
	System.exit(1);
     }
   static public void stopserver()
     {
	keeponrunning=false;
     }
   static void evaluate_httpd(InputStream inport, OutputStream outport)
     {
	Cons AG=new Cons(Identifier.newId("eval-http"),new Cons(inport, new Cons(outport,null)));
	Scheme.evaluate(AG);
     }
   static void eval_idle()
     {
	Cons AG=new Cons(Identifier.newId("eval-idle"),null);
	Scheme.evaluate(AG);
     }
   static public void main(String argv[])
     {
	// scheme starten met inlezen van startfiles
	Scheme.main(argv);
	boolean idledone=false;
	// httpd starten.
	try
	  {
	     httpd=new igtool();
	     httpd.setSoTimeout(600000);
	     while(keeponrunning)
	       {
		  Socket s=null;;
		  try
		    {
		       s=httpd.accept();
		    }
		  catch (IOException e)
		    {
		       if (!idledone)
			 {
			    idledone=true;
			    eval_idle();
			 }
		    }
		  if (s!=null)
		    {
		       idledone=false;
		       InputStream inport=s.getInputStream();
		       OutputStream outport=s.getOutputStream();
		       evaluate_httpd(inport,outport);
		       inport.close();
		       outport.close();
		       java.lang.Runtime.getRuntime().gc();
		    }
	       }
	     httpd.close();
	  }
	catch (Exception e) 
	  {
	     fatal(e.toString());
	  }
	
     }
}
